from ltr.admin.environment import env_settings
from pytracking.evaluation.euler_data_preparation import prepare_data_euler


def prepare_train_data_euler(name):
    dataset_dict = dict(
        lasot=env_settings().lasot_root_euler,
        coco=env_settings().coco_root_euler,
        got10k=env_settings().got10k_root_euler,
        trackingnet=env_settings().trackingnet_root_euler
    )
    prepare_data_euler(src_data_dir=dataset_dict[name])


def get_dataset(name, constructor, kwargs=None):
    if kwargs is None:
        kwargs = {}

    if getattr(env_settings(), 'on_euler', False):
        prepare_train_data_euler(name)

    return constructor(**kwargs)